﻿using System.Windows;
using ThinkGeo.MapSuite;
using ThinkGeo.MapSuite.Layers;
using ThinkGeo.MapSuite.Styles;
using ThinkGeo.MapSuite.Drawing;
using ThinkGeo.MapSuite.Shapes;
using ThinkGeo.MapSuite.Wpf;
using ThinkGeo.MapSuite.Serialize;
using System.Collections.ObjectModel;

namespace _8757
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void map_Loaded(object sender, RoutedEventArgs e)
        {
            map.MapUnit = GeographyUnit.DecimalDegree;
            map.MapClick += Map_MapClick;

            LayerOverlay layerOverlay = new LayerOverlay();
            ShapeFileFeatureLayer shapeFileLayer = new ShapeFileFeatureLayer(@"..\..\AppData\states.shp");
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle = WorldStreetsAreaStyles.Military();
            shapeFileLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
            layerOverlay.Layers.Add(shapeFileLayer);
            map.Overlays.Add(layerOverlay);

            shapeFileLayer.Open();
            map.CurrentExtent = shapeFileLayer.GetBoundingBox();
            map.Refresh();
        }

        private void Map_MapClick(object sender, MapClickWpfMapEventArgs e)
        {
            PointShape clickedPoint = e.WorldLocation;

            ShapeFileFeatureLayer shapeFileLayer = (map.Overlays[0] as LayerOverlay).Layers[0] as ShapeFileFeatureLayer;
            Collection<Feature> features = shapeFileLayer.QueryTools.GetFeaturesNearestTo(clickedPoint, GeographyUnit.Meter, 1, ReturningColumnsType.NoColumns);

            Feature fea = features[0];

            map.EditOverlay.EditShapesLayer.InternalFeatures.Add(fea);
            map.EditOverlay.CalculateAllControlPoints();
            map.Refresh();
        }
    }
}
